<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\CentroCustoRelatorioService;
use SM\Traits\TResponse;

class CentroCustoRelatorioController extends SMCrud
{

    use TResponse;

    protected $centroCustoRelatorioService;

    public function __construct($crudService, $environment, centroCustoRelatorioService $centroCustoRelatorioService)
    {
        parent::__construct($crudService, $environment);
        $this->centroCustoRelatorioService = $centroCustoRelatorioService;
    }

    public function getCentroCustoRelatorio()
    {
        try {
            $data = $this->centroCustoRelatorioService->getCentroCustoRelatorio();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function atualizarView()
    {
        try {
            $data = $this->centroCustoRelatorioService->atualizarView();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDataUltimaAtualizacaoRelatorioCentroCusto()
    {
        try {
            $data = $this->centroCustoRelatorioService->getDataUltimaAtualizacaoRelatorioCentroCusto();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
