<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmCargoInterlocService;

class CrmCargoInterlocController
{
    protected $CargoInterlocService;

    use TResponse;

    public function __construct(CrmCargoInterlocService $CargoInterlocService)
    {
        $this->CargoInterlocService = $CargoInterlocService;
    }

    public function getCargosInterlocutor()
    {
        try {
            $data = $this->CargoInterlocService->getCargosInterlocutor();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveCargoInterlocutor(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->CargoInterlocService->saveCargoInterlocutor($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteCargoInterlocutor(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->CargoInterlocService->deleteCargoInterlocutor($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
