<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmRamodeAtividadeService;

class CrmRamodeAtividadeController
{
    protected $CrmRamodeAtividadeService;

    use TResponse;

    public function __construct(CrmRamodeAtividadeService $CrmRamodeAtividadeService)
    {
        $this->CrmRamodeAtividadeService = $CrmRamodeAtividadeService;
    }

    public function getFieldMarket()
    {
        try {
            $data = $this->CrmRamodeAtividadeService->getFieldMarket();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    public function getBranchOfActivity()
    {
        try {
            $data = $this->CrmRamodeAtividadeService->getBranchOfActivity();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


    public function saveNewBranch(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->CrmRamodeAtividadeService->saveNewBranchService($params);
        } catch (\Exception $e) {

            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteBranchOfActivity(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->CrmRamodeAtividadeService->deleteBranchOfActivity($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
