<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\Ger10120SegmentoMercadoService;

class Ger10120SegmentoMercadoController
{
    protected $SegmentoMercadoService;

    use TResponse;

    public function __construct(Ger10120SegmentoMercadoService $SegmentoMercadoService)
    {
        $this->SegmentoMercadoService = $SegmentoMercadoService;
    }

    public function getSegmentosMercado()
    {
        try {
            $data = $this->SegmentoMercadoService->getSegmentosMercado();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveSegmentoMercado(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->SegmentoMercadoService->saveSegmentoMercado($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteSegmentoMercado(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->SegmentoMercadoService->deleteSegmentoMercado($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
