<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\JustifCancelaApurService;
use SM\Traits\TResponse;

class JustifCancelaApurController
{

    use TResponse;

    protected $justifCancelaApurService;

    public function __construct(JustifCancelaApurService $justifCancelaApurService)
    {
        $this->justifCancelaApurService = $justifCancelaApurService;
    }

    public function getJustifCancelaApur()
    {
        try {
            $data = $this->justifCancelaApurService->getJustifCancelaApur();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function editJustifCancelaApur(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->justifCancelaApurService->editJustifCancelaApur($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteJustifCancelaApur(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->justifCancelaApurService->deleteJustifCancelaApur($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
