<?php

namespace CRM\Factory;

use Doctrine\ORM\EntityManager;
use CRM\Traits\TQuery;

class CrmCargoInterlocFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCargosInterlocutor()
    {
        $sql = "SELECT * FROM CARGOINTERLOC ORDER BY CDCARGOINTERLOC ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertCargoInterlocutor($params)
    {
        $sql = "INSERT INTO CARGOINTERLOC ( 
                    CDCARGOINTERLOC,    NMCARGOINTERLOC,    DTULTATU,
                    NRORG,              DTINCLUSAO,         NRORGINCLUSAO,
                    CDOPERINCLUSAO,     NRORGULTATU,        CDOPERULTATU,
                    IDATIVO
                )
                VALUES (
                    :CDCARGOINTERLOC,   :NMCARGOINTERLOC,   SYSDATE,
                    :NRORG,             SYSDATE,            :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,    :NRORGULTATU,       :CDOPERULTATU,
                    :IDATIVO
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function editCargoInterlocutor($params)
    {
        $sql = "UPDATE CARGOINTERLOC
                SET NMCARGOINTERLOC = :NMCARGOINTERLOC,
                    DTULTATU        = SYSDATE,
                    NRORGULTATU     = :NRORGULTATU,
                    CDOPERULTATU    = :CDOPERULTATU,
                    IDATIVO         = :IDATIVO
                WHERE CDCARGOINTERLOC = :CDCARGOINTERLOC";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteCargoInterlocutor($params)
    {
        $sql = "DELETE
                FROM CARGOINTERLOC
                WHERE CDCARGOINTERLOC IN (".$params.")";
        
        $this->connection->executeStatement($sql);
    }
}
