<?php

namespace CRM\Factory;

use Doctrine\ORM\EntityManager;
use CRM\Traits\TQuery;

class CrmModoReceberInfoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getReceiveInfo()
    {
        $sql = "SELECT * FROM CRM_MODORECEBINFO ORDER BY NMMODORECEBINFO ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function saveReceiveInfo($parametros)
    {
        try {
            $sql = "INSERT INTO CRM_MODORECEBINFO (
                        NRMODORECEBINFO,    IDATIVO,      NRORGINCLUSAO,
                        NMMODORECEBINFO,    DTINCLUSAO,   CDOPERINCLUSAO,
                        NRORG,              DTULTATU,     NRORGULTATU,
                        CDOPERULTATU     
                    ) VALUES (
                        :NRMODORECEBINFO,   :IDATIVO,      :NRORGINCLUSAO,
                        :NMMODORECEBINFO,   SYSDATE,       :CDOPERINCLUSAO,
                        :NRORG,             SYSDATE,       :NRORGULTATU,
                        :CDOPERULTATU
            )";

            $this->connection->executeStatement($sql, $parametros);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function updateReceiveInfo($parametros)
    {
        $sql = "UPDATE CRM_MODORECEBINFO
                SET NRMODORECEBINFO     = :NRMODORECEBINFO,
                    NMMODORECEBINFO     = :NMMODORECEBINFO,
                    DTULTATU            = SYSDATE,
                    DTINCLUSAO          = SYSDATE,
                    NRORGULTATU         = :NRORGULTATU,
                    CDOPERULTATU        = :CDOPERULTATU,
                    IDATIVO             = :IDATIVO
                WHERE NRMODORECEBINFO   = :NRMODORECEBINFO";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function deleteReceiveInfo($parametro)
    {
        $sql = "DELETE
                FROM CRM_MODORECEBINFO
                WHERE NRMODORECEBINFO IN (" . $parametro . ")";

        $this->connection->executeStatement($sql);
    }
}
