<?php

namespace CRM\Factory;

use Doctrine\ORM\EntityManager;
use CRM\Traits\TQuery;

class Ger10120SegmentoMercadoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getSegmentosMercado()
    {
        $sql = "SELECT * FROM SEGMERCADO ORDER BY DSSEGMER ASC";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertSegmentoMercado($params)
    {
        try {
            $sql = "INSERT INTO SEGMERCADO (
                        CDSEGMER,       DSSEGMER,       DTULTATUSEGM,
                        NRORG,          DTINCLUSAO,     DTULTATU,
                        NRORGINCLUSAO,  CDOPERINCLUSAO, NRORGULTATU,
                        CDOPERULTATU,   IDATIVO
                    )
                    VALUES (
                        :CDSEGMER,      :DSSEGMER,       SYSDATE,
                        :NRORG,         SYSDATE,         SYSDATE,
                        :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU,
                        :CDOPERULTATU,  :IDATIVO
                    )";
            
            $this->connection->executeStatement($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public function editSegmentoMercado($params)
    {
        $sql = "UPDATE SEGMERCADO
                SET DSSEGMER     = :DSSEGMER,
                    DTULTATUSEGM = SYSDATE,
                    DTULTATU     = SYSDATE,
                    NRORGULTATU  = :NRORGULTATU,
                    CDOPERULTATU = :CDOPERULTATU,
                    IDATIVO      = :IDATIVO
                WHERE CDSEGMER   = :CDSEGMER";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteSegmentoMercado($param)
    {
        $sql = "DELETE
                FROM SEGMERCADO
                WHERE CDSEGMER IN (".$param.")";

        $this->connection->executeStatement($sql);
    }
}
