<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class Ger91600TipoDeAtividadeFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTypeOfActivityFactory()
    {

        $sql = "SELECT TIPO.*, RAMO.DSATIVCLI 
                FROM TPATIVCLIENTE TIPO 
                JOIN ATIVCLIENTE RAMO
                ON RAMO.CDATIVCLI = TIPO.CDATIVCLI 
                AND RAMO.NRORG = TIPO.NRORG 
                ORDER BY DSATIVCLI ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFieldOfActivityFactory()
    {

        $sql = "SELECT RAMO.*, SEGM.DSSEGMER 
        FROM ATIVCLIENTE RAMO
        LEFT JOIN SEGMERCADO SEGM 
        ON RAMO.CDSEGMER = SEGM.CDSEGMER 
        AND RAMO.NRORG = SEGM.NRORG 
        AND RAMO.IDATIVO = SEGM.IDATIVO ORDER BY DSATIVCLI ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertNewActivityFactory($params)
    {

        $sql = "INSERT INTO TPATIVCLIENTE (
                NRSEQTPATIVCLI, NRORG, CDATIVCLI, 
                DSTPATIVCLIENTE, DTINCLUSAO, DTULTATU, 
                NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, 
                CDOPERULTATU, IDATIVO)
                VALUES (
                :NRSEQTPATIVCLI, :NRORG, :CDATIVCLI, 
                :DSTPATIVCLIENTE, SYSDATE, SYSDATE, 
                :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, 
                :CDOPERULTATU, :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateActivityFactory($params)
    {

        $sql = "UPDATE TPATIVCLIENTE  
                SET NRSEQTPATIVCLI = :NRSEQTPATIVCLI, 
                    NRORG = :NRORG, 
                    CDATIVCLI = :CDATIVCLI, 
                    DSTPATIVCLIENTE = :DSTPATIVCLIENTE, 
                    DTINCLUSAO = SYSDATE, 
                    DTULTATU = SYSDATE, 
                    NRORGINCLUSAO = :NRORGINCLUSAO, 
                    CDOPERINCLUSAO = :CDOPERINCLUSAO, 
                    NRORGULTATU = :NRORGULTATU, 
                    CDOPERULTATU = :CDOPERULTATU, 
                    IDATIVO = :IDATIVO
                WHERE NRSEQTPATIVCLI = :NRSEQTPATIVCLI
                AND   NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteActivityFactory($params)
    {

        $sql = "DELETE FROM TPATIVCLIENTE 
                WHERE NRSEQTPATIVCLI = :NRSEQTPATIVCLI";

        $this->connection->executeStatement($sql, $params);
    }

    public function findRelationshipFactory($params)
    {

        $sql = "SELECT COUNT (NRSEQTPATIVCLI) AS NRSEQTPATIVCLI  FROM PARCNEGOCIO 
                WHERE NRSEQTPATIVCLI = :NRSEQTPATIVCLI";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }
}
