<?php

namespace CRM\Service;

use CRM\Factory\CrmCargoInterlocFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmCargoInterlocService
{
    
    protected $CargoInterlocFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, CrmCargoInterlocFactory $CargoInterlocFactory)
    {
        $this->CargoInterlocFactory         = $CargoInterlocFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getCargosInterlocutor()
    {
        return $this->CargoInterlocFactory->getCargosInterlocutor();
    }

    public function saveCargoInterlocutor($params)
    {
        $this->connection->beginTransaction();
        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();

            foreach ($params["DRG"] as $row) {
                if ($row["CDCARGOINTERLOC"] == 0) {
                    $cdCargoInterloc = $this->newCode->getCodeByTableName("CARGOINTERLOC", $nrorg, 1, 5, false);
                    
                    $parametros = array (
                        "CDCARGOINTERLOC"   => $cdCargoInterloc,
                        "NMCARGOINTERLOC"   => $row["NMCARGOINTERLOC"],
                        "NRORG"             => $nrorg,
                        "NRORGINCLUSAO"     => $nrorg,
                        "CDOPERINCLUSAO"    => $operador,
                        "NRORGULTATU"       => $nrorg,
                        "CDOPERULTATU"      => $operador,
                        "IDATIVO"           => $row["IDATIVO"]
                    );

                    $this->CargoInterlocFactory->insertCargoInterlocutor($parametros);
                } else {
                    $parametros = array (
                        "CDCARGOINTERLOC"   => $row["CDCARGOINTERLOC"],
                        "NMCARGOINTERLOC"   => $row["NMCARGOINTERLOC"],
                        "NRORGULTATU"       => $nrorg,
                        "CDOPERULTATU"      => $operador,
                        "IDATIVO"           => $row["IDATIVO"]
                    );

                    $this->CargoInterlocFactory->editCargoInterlocutor($parametros);
                }
            }

            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
            throw $ex;
        }
    }

    public function deleteCargoInterlocutor($params)
    {
        $parametros = implode(',', $params["CDGS"]);
        $this->CargoInterlocFactory->deleteCargoInterlocutor($parametros);
    }
}
