<?php

namespace CRM\Service;

use CRM\Factory\CrmClassificacaoDeOportunidadeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmClassificacaoDeOportunidadeService
{

    protected $CrmClassificacaoDeOportunidadeFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmClassificacaoDeOportunidadeFactory $CrmClassificacaoDeOportunidadeFactory)
    {
        $this->CrmClassificacaoDeOportunidadeFactory   = $CrmClassificacaoDeOportunidadeFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getSortOfOpportunityService()
    {
        return $this->CrmClassificacaoDeOportunidadeFactory->getSortOfOpportunityFactory();
    }

    public function saveSortOfOpportunityService($row)
    {

        $this->connection->beginTransaction();
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();

        try {
            foreach ($row["DRG"] as $rows) {

                if ($rows["NRSEQCLASSOPORT"] == 0) {

                    $rows["NRSEQCLASSOPORT"] = $this->newCode->getCodeByTableName("CRMCLASSOPORTUNI", $nrorg, 1, 5, false);

                    $params = array(
                        "NRSEQCLASSOPORT"   => $rows["NRSEQCLASSOPORT"],
                        "NMCLASSOPORT"      => $rows["NMCLASSOPORT"],
                        "IDATIVO"           => $rows["IDATIVO"],
                        "NRORG"             => $nrorg,
                        "NRORGINCLUSAO"     => $nrorg,
                        "NRORGULTATU"       => $nrorg,
                        "CDOPERINCLUSAO"    => $cdoperador,
                        "CDOPERULTATU"      => $cdoperador
                    );

                    $this->CrmClassificacaoDeOportunidadeFactory->saveSortOfOpportunityFactory($params);
                } else {

                    $params = array(
                        "NRSEQCLASSOPORT"   => $rows["NRSEQCLASSOPORT"],
                        "NMCLASSOPORT"      => $rows["NMCLASSOPORT"],
                        "IDATIVO"           => $rows["IDATIVO"],
                        "NRORG"             => $nrorg,
                        "NRORGINCLUSAO"     => $nrorg,
                        "NRORGULTATU"       => $nrorg,
                        "CDOPERINCLUSAO"    => $cdoperador,
                        "CDOPERULTATU"      => $cdoperador
                    );

                    $this->CrmClassificacaoDeOportunidadeFactory->updateSortOfOpportunityFactory($params);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteSortOfOpportunityService($row)
    {
        $params = implode(',', $row["NRSQ"]);
        $this->CrmClassificacaoDeOportunidadeFactory->deleteSortOfOpportunityFactory($params);
    }
}
