<?php

namespace CRM\Service;

use CRM\Factory\CrmModoReceberInfoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmModoReceberInfoService
{

    protected $CrmModoReceberInfoFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, CrmModoReceberInfoFactory $CrmModoReceberInfoFactory)
    {
        $this->CrmModoReceberInfoFactory           = $CrmModoReceberInfoFactory;
        $this->Environment                         = $Environment;
        $this->newCode                             = $newCode;
        $this->connection                          = $entityManager->getConnection();
    }

    public function getReceiveInfo()
    {
        return $this->CrmModoReceberInfoFactory->getReceiveInfo();
    }

    public function saveReceiveInfo($params)
    {
        $this->connection->beginTransaction();
        $nrorg = $this->Environment->getNrorg();
        $operador = $this->Environment->getCdOperador();
        try {
            foreach ($params["DRG"] as $row) {

                if ($row["NRMODORECEBINFO"] == 0) {

                    $nrmodorecebinfo = $this->newCode->getCodeByTableName("CRM_MODORECEBINFO", $nrorg, 1, 10, true);

                    $parametros = array(
                        "NRMODORECEBINFO" => $nrmodorecebinfo,
                        "NMMODORECEBINFO" => $row['NMMODORECEBINFO'],
                        "IDATIVO"         => $row['IDATIVO'],
                        "NRORG"           => $nrorg,
                        "NRORGINCLUSAO"   => $nrorg,
                        "NRORGULTATU"     => $nrorg,
                        "CDOPERINCLUSAO"  => $operador,
                        "CDOPERULTATU"    => $operador,
                    );

                    $this->CrmModoReceberInfoFactory->saveReceiveInfo($parametros);
                } else {

                    $parametros = array(
                        "NRMODORECEBINFO" => $row["NRMODORECEBINFO"],
                        "NMMODORECEBINFO" => $row['NMMODORECEBINFO'],
                        "IDATIVO"         => $row['IDATIVO'],
                        "NRORG"           => $nrorg,
                        "NRORGINCLUSAO"   => $nrorg,
                        "NRORGULTATU"     => $nrorg,
                        "CDOPERINCLUSAO"  => $operador,
                        "CDOPERULTATU"    => $operador,
                    );

                    $this->CrmModoReceberInfoFactory->updateReceiveInfo($parametros);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteReceiveInfo($params)
    {
        $parametro = implode(',', $params["NRMODORECEBINFO"]);
        print_r($parametro);
        $this->CrmModoReceberInfoFactory->deleteReceiveInfo($parametro);
    }
}
