<?php

namespace CRM\Service;

use CRM\Factory\CrmRamodeAtividadeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmRamodeAtividadeService
{

    protected $CrmRamodeAtividadeFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmRamodeAtividadeFactory $CrmRamodeAtividadeFactory)
    {
        $this->CrmRamodeAtividadeFactory    = $CrmRamodeAtividadeFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getBranchOfActivity()
    {
        return $this->CrmRamodeAtividadeFactory->getBranchOfActivity();
    }

    public function getFieldMarket()
    {
        return $this->CrmRamodeAtividadeFactory->getFieldMarket();
    }

    public function saveNewBranchService($params)
    {
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        $cdnvativcli = 1;
        $this->connection->beginTransaction();
        try {
            foreach ($params["DRG"] as $row) {
                if ($row["CDATIVCLI"] == 0) {

                    $cdativcli = $this->newCode->getCodeByTableName("ATIVCLIENTE", $nrorg, 1, 5, false);
                    $parametro = array(
                        "CDATIVCLI"      => $cdativcli,
                        "CDARVATIVCLI"   => $cdativcli,
                        "IDATIVO"        => $row["IDATIVO"],
                        "DSATIVCLI"      => $row["DSATIVCLI"],
                        "CDSEGMER"       => $row["CDSEGMER"],
                        "CDNVATIVCLI"    => $cdnvativcli,
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERINCLUSAO" => $cdoperador,
                        "CDOPERULTATU"   => $cdoperador
                    );
                    $this->CrmRamodeAtividadeFactory->insertNewBranchFactory($parametro);
                } else {

                    $parametro = array(
                        "CDATIVCLI"      => $row["CDATIVCLI"],
                        "CDARVATIVCLI"   => $row["CDATIVCLI"],
                        "IDATIVO"        => $row["IDATIVO"],
                        "DSATIVCLI"      => $row["DSATIVCLI"],
                        "CDSEGMER"       => $row["CDSEGMER"],
                        "CDNVATIVCLI"    => $cdnvativcli,
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERINCLUSAO" => $cdoperador,
                        "CDOPERULTATU"   => $cdoperador
                    );

                    $this->CrmRamodeAtividadeFactory->updateNewBranchFactory($parametro);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteBranchOfActivity($params)
    {
        $parametro = implode(',', $params["CDAT"]);
        $this->CrmRamodeAtividadeFactory->deleteBranchOfActivity($parametro);
    }
}
