<?php

namespace CRM\Service;

use CRM\Factory\Ger10120SegmentoMercadoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Ger10120SegmentoMercadoService
{

    protected $SegmentoMercadoFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, Ger10120SegmentoMercadoFactory $SegmentoMercadoFactory)
    {
        $this->SegmentoMercadoFactory       = $SegmentoMercadoFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getSegmentosMercado()
    {
        return $this->SegmentoMercadoFactory->getSegmentosMercado();
    }

    public function saveSegmentoMercado($params)
    {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();

            foreach($params["DRG"] as $row) {
                if ($row["CDSEGMER"] == 0) {
                    $cdSegMer = $this->newCode->getCodeByTableName("SEGMERCADO", $nrorg, 1, 5, false);

                    $parametros = array (
                        "CDSEGMER"       => $cdSegMer,
                        "DSSEGMER"       => $row["DSSEGMER"],
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "CDOPERINCLUSAO" => $operador,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERULTATU"   => $operador,
                        "IDATIVO"        => $row["IDATIVO"]
                    );

                    $this->SegmentoMercadoFactory->insertSegmentoMercado($parametros);
                } else {
                    $parametros = array (
                        "CDSEGMER"      => $row["CDSEGMER"],
                        "DSSEGMER"      => $row["DSSEGMER"],
                        "NRORGULTATU"   => $nrorg,
                        "CDOPERULTATU"  => $operador,
                        "IDATIVO"       => $row["IDATIVO"]
                    );

                    $this->SegmentoMercadoFactory->editSegmentoMercado($parametros);
                }
            }

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteSegmentoMercado($params)
    {
        $parametro = implode(',', $params["CDGS"]);
        $this->SegmentoMercadoFactory->deleteSegmentoMercado($parametro);
    }
}
